program assessed2;
{$APPTYPE CONSOLE}

{
  Program to process a list of variable declarations and a list of function definitions into a list of results.
  The results of functions are available to functions evaluated subsequently.
  Deals with AND, OR & NOT(
  Syntax must be strict. - One space between lexemes, except before & after '='
                                                          andyjpb@ashurst.eu.org
                                                                       2003/3/21
}

uses
  SysUtils,
  binStreamsU in 'binStreamsU.pas',
  parseTreeU in 'parseTreeU.pas',
  lexemeListU in 'lexemeListU.pas';

{ Main Program }
const
  IinFilename = 'IFile.TXT'; { File from which to read binary streams }
  DinFilename = 'DFile.TXT'; { File from which to read function definitions }
  OoutFilename = 'OFile.TXT'; { File to which to write results }

var
  binStreams: TbinStreams; { Pointer to list of binary streams in memory }
  results: TbinStreams; { Pointer to list of binary streams for results }
  parseTrees: TparseTrees; { Pointer to a list of parse trees for the results }

begin
  { Variable initialisation }
  binStreams := emptyBinStreams(); { Make an empty set of binStreams }
  results := emptyBinStreams(); { Make an empty set of results }
  parseTrees := emptyParseTrees(); { Make an empty set of parse trees }
  { End of variable initialisation };

  fetchStreamsFromFile(IinFilename, binStreams); { Read the input binary streams from a file }
  fetchFunctionsFromFile(DinFilename, parseTrees); { Read the function definitions from a file }

  results := evaluateFunctions(binStreams, parseTrees, results); { Evaluate the functions and store the results in list of binary streams }
  putResultsToFile(OoutFilename, results); { Write the binary stream of results out to a file }

end.
